---@meta

---@class AAVS_Vehicle_C : AVehicleSystemBase
---@field UberGraphFrame FPointerToUberGraphFrame
---@field Wheels TArray<UVehicle_Wheel_C>
---@field ConstructCalled boolean
---@field Initialized boolean
---@field EngineAudio UVehicle_EngineAudio_C
---@field RPM double
---@field dRPM double
---@field StartWithPhysics boolean
---@field StabilityControl boolean
---@field StabilityControlForce double
---@field DynamicAirDrag boolean
---@field BaseLinearDrag double
---@field PhysicsMaterial UPhysicalMaterial
---@field NumDrivingWheels int32
---@field EngineRunning boolean
---@field AllowPassiveMode boolean
---@field StartWithEngineRunning boolean
---@field ZeroThrottleWhileShifting boolean
---@field SpeedUnits SpeedUnits::Type
---@field SpeedUnit FSpeedUnit
---@field IgnitionTime double
---@field Shifter ShifterPositions::Type
---@field AutomaticShifterPositon boolean
---@field AutomaticTransmission boolean
---@field GearSwitchTime double
---@field InputHost AAVS_Vehicle_C
---@field ThrottleInput double
---@field Throttle double
---@field BrakeInput double
---@field Brake double
---@field Steering double
---@field isBrakeApplied boolean
---@field HandbrakeApplied boolean
---@field ServerEngineRunning boolean
---@field IgnitionTimer FTimerHandle
---@field Acceleration double
---@field AirSpeed double
---@field TargetSpeed double
---@field Torque double
---@field Slip double
---@field Gear FVehicleGear
---@field CurrentGear int32
---@field LightControllers TArray<UVehicle_LightController_C>
---@field Exhausts TArray<UVehicle_ExhaustController_C>
---@field ActiveLightGroups TArray<FName>
---@field previousGear int32
---@field isShifting boolean
---@field ThrottleCurve UCurveFloat
---@field GearCurve UCurveFloat
---@field SteeringInput double
---@field GearInput int32
---@field VisualizeCenterOfMass boolean
---@field OverrideCenterOfMass boolean
---@field RelativeCenterOfMass FVector
---@field DefaultCOM FVector
---@field AccelerationConfig boolean
---@field TargetAcceleration double
---@field DynamicMaxTorque double
---@field CenterOfMassOffset FVector
---@field IdleRPM double
---@field IdleMaxRPM double
---@field SyncAsTrailer boolean
---@field TrailerSyncTimer FTimerHandle
---@field LocalTrailerRotation FRotator
---@field HostTrailerRotation FRotator
---@field NetworkTowHitch UVehicle_Hitch_C
---@field NetworkTrailerHitch UVehicle_Hitch_C
---@field VehicleMaxAngularVelocity double
---@field WheelReprojection boolean
---@field ReprojectionSmoothAlpha double
---@field TickDelta double
---@field CinematicPlayback boolean
---@field WheelReprojectionCamber boolean
---@field CamberCompressed FVector2D
---@field CamberDecompressed FVector2D
---@field ContactModificationDirty boolean
---@field TPS_Timer FTimerHandle
---@field LocalSteeringInput double
---@field SuspensionDebug boolean
---@field DisplayDebugMenu boolean
---@field DebugMenu UVehicleSetup_HUD_C
---@field DebugMeshes TArray<UPrimitiveComponent>
---@field DebugCOM UStaticMeshComponent
---@field OnEngineRunningUpdatedEvent FAVS_Vehicle_COnEngineRunningUpdatedEvent
---@field VehicleSpeedFromWheelRotation double
---@field PreviousShifter ShifterPositions::Type
local AAVS_Vehicle_C = {}

---@param PreviousValue ShifterPositions::Type
---@param NewValue ShifterPositions::Type
function AAVS_Vehicle_C:OnShifterUpdatedEvent(PreviousValue, NewValue) end
---@param IsEngineRunning boolean
function AAVS_Vehicle_C:OnEngineRunningUpdated(IsEngineRunning) end
---@param BrakeInputValue double
function AAVS_Vehicle_C:OnBrakeInputUpdated(BrakeInputValue) end
---@param LinearDamping double
function AAVS_Vehicle_C:SetLinearDamping(LinearDamping) end
function AAVS_Vehicle_C:CalculateSteering() end
function AAVS_Vehicle_C:TickInputs() end
---@param Brake double
function AAVS_Vehicle_C:GetBrake(Brake) end
---@param Throttle double
function AAVS_Vehicle_C:GetThrottle(Throttle) end
---@param RPM double
function AAVS_Vehicle_C:GetRPM(RPM) end
function AAVS_Vehicle_C:ToogleDebugMenu() end
function AAVS_Vehicle_C:DebugDraw() end
function AAVS_Vehicle_C:DebugPassiveText() end
---@param NewPassiveState boolean
function AAVS_Vehicle_C:PassiveStateChanged(NewPassiveState) end
---@return boolean
function AAVS_Vehicle_C:DeterminePassiveState() end
function AAVS_Vehicle_C:SyncTrailer() end
---@param Instant boolean
function AAVS_Vehicle_C:RefreshContactModification(Instant) end
---@param RegisterSuccess boolean
function AAVS_Vehicle_C:SetupWheelContactModification(RegisterSuccess) end
---@param Wheel UVehicle_Wheel_C
function AAVS_Vehicle_C:CreateSuspensionPreview(Wheel) end
---@param Wheel UVehicle_Wheel_C
function AAVS_Vehicle_C:UpdateWheelTorque(Wheel) end
---@param Mesh UStaticMeshComponent
---@param Material UMaterialInterface
function AAVS_Vehicle_C:SetMeshMaterial(Mesh, Material) end
function AAVS_Vehicle_C:SuspensionPreview() end
function AAVS_Vehicle_C:OnRep_Shifter() end
function AAVS_Vehicle_C:OnRep_SteeringInput() end
function AAVS_Vehicle_C:OnRep_BrakeInput() end
function AAVS_Vehicle_C:OnRep_ThrottleInput() end
function AAVS_Vehicle_C:WakePhysics() end
---@param IsCinematic boolean
function AAVS_Vehicle_C:IsCinematic(IsCinematic) end
function AAVS_Vehicle_C:UpdateLinearDamping() end
---@param WheelContact boolean
function AAVS_Vehicle_C:AnyWheelContact(WheelContact) end
function AAVS_Vehicle_C:DoStabilityControl() end
---@param Target UActorComponent
function AAVS_Vehicle_C:DestroyOwnedComponent(Target) end
function AAVS_Vehicle_C:AutomaticShifterPosition() end
function AAVS_Vehicle_C:ReprojectWheels() end
function AAVS_Vehicle_C:InitWheelReprojectionExperiment() end
---@param HostTrailerRotation FRotator
function AAVS_Vehicle_C:GetHostTrailerRotation(HostTrailerRotation) end
---@param Index int32
---@param NewGearSettings FVehicleGear
function AAVS_Vehicle_C:SetGearItem(Index, NewGearSettings) end
---@param Gears TArray<FVehicleGear>
function AAVS_Vehicle_C:SetGearArray(Gears) end
---@param OwningClient boolean
function AAVS_Vehicle_C:isOwningClient(OwningClient) end
---@param InputHost AAVS_Vehicle_C
function AAVS_Vehicle_C:SetInputHost(InputHost) end
function AAVS_Vehicle_C:CopyInputsFromHost() end
---@param WheelComponent UVehicle_Wheel_C
function AAVS_Vehicle_C:DestroyWheelMesh(WheelComponent) end
---@param WheelComponent UVehicle_Wheel_C
---@param NewMesh UPrimitiveComponent
function AAVS_Vehicle_C:CreateWheelMesh(WheelComponent, NewMesh) end
function AAVS_Vehicle_C:UnhitchAll() end
---@param Wheel UVehicle_Wheel_C
function AAVS_Vehicle_C:RemoveWheel(Wheel) end
---@param NewWheel UVehicle_Wheel_C
function AAVS_Vehicle_C:AddWheel(NewWheel) end
---@param bManualAttachment boolean
---@param RelativeTransform FTransform
---@param VehicleConstraint UVehicleConstraint
---@param PhysicsHandle UPhysicsHandleComponent
function AAVS_Vehicle_C:CreateHitchConstraints(bManualAttachment, RelativeTransform, VehicleConstraint, PhysicsHandle) end
---@param RelativeCOM FVector
function AAVS_Vehicle_C:SetCenterOfMassOffset(RelativeCOM) end
function AAVS_Vehicle_C:StartupEngine() end
function AAVS_Vehicle_C:OnRep_ServerEngineRunning() end
function AAVS_Vehicle_C:OnRep_EngineRunning() end
---@param SpeedUnit FSpeedUnit
function AAVS_Vehicle_C:GetSpeedUnitData(SpeedUnit) end
function AAVS_Vehicle_C:Cleanup() end
---@param Acceleration double
function AAVS_Vehicle_C:GetAcceleration(Acceleration) end
function AAVS_Vehicle_C:InitSpeedUnit() end
---@param ExactCOM FVector
---@param IsValid boolean
function AAVS_Vehicle_C:GetExactCenterOfMass(ExactCOM, IsValid) end
---@param NewCenterOfMass FVector
function AAVS_Vehicle_C:SetExactCenterOfMass(NewCenterOfMass) end
function AAVS_Vehicle_C:DetachAllWheels() end
function AAVS_Vehicle_C:ResetAllWheels() end
function AAVS_Vehicle_C:ApplyCOM() end
function AAVS_Vehicle_C:InitCOM() end
---@param Handbrake boolean
function AAVS_Vehicle_C:SetHandbrakeInput(Handbrake) end
---@param Shifter_Position ShifterPositions::Type
function AAVS_Vehicle_C:SetShifterPosition(Shifter_Position) end
---@param Steering double
function AAVS_Vehicle_C:SetSteeringInput(Steering) end
---@param Brake double
function AAVS_Vehicle_C:SetBrakeInput(Brake) end
---@param Throttle double
function AAVS_Vehicle_C:SetThrottleInput(Throttle) end
---@param Throttle double
function AAVS_Vehicle_C:SetThrottleAndBrakeInput(Throttle) end
function AAVS_Vehicle_C:SetupSkeletalMeshes() end
---@param SteeringInput double
function AAVS_Vehicle_C:GetCurrentSteeringInput(SteeringInput) end
---@param CurrentSteering double
function AAVS_Vehicle_C:GetCurrentSteering(CurrentSteering) end
---@param bManualAttachment boolean
---@param RelativeTransform FTransform
---@param VehicleConstraint UVehicleConstraint
function AAVS_Vehicle_C:CreateBoneConstraint(bManualAttachment, RelativeTransform, VehicleConstraint) end
---@param bManualAttachment boolean
---@param RelativeTransform FTransform
---@param VehicleConstraint UVehicleConstraint
function AAVS_Vehicle_C:CreateNewConstraint(bManualAttachment, RelativeTransform, VehicleConstraint) end
---@param bManualAttachment boolean
---@param RelativeTransform FTransform
---@param Mesh UStaticMeshComponent
function AAVS_Vehicle_C:CreateNewWheelController(bManualAttachment, RelativeTransform, Mesh) end
---@param GearNumber int32
---@param SelectedGear FVehicleGear
function AAVS_Vehicle_C:GetSelectedGear(GearNumber, SelectedGear) end
---@param isHandbrakeApplied boolean
function AAVS_Vehicle_C:GetHandbrakeApplied(isHandbrakeApplied) end
function AAVS_Vehicle_C:ValidateTransmission() end
---@param Slip double
function AAVS_Vehicle_C:GetSlip(Slip) end
function AAVS_Vehicle_C:InitAudio() end
---@param GearNum int32
function AAVS_Vehicle_C:SetManualGear(GearNum) end
---@param EngineRunning boolean
function AAVS_Vehicle_C:SetLocalEngineRunning(EngineRunning) end
---@param ShifterPos ShifterPositions::Type
function AAVS_Vehicle_C:GetShifterPosition(ShifterPos) end
---@param Gear int32
---@param CurrentGear FVehicleGear
function AAVS_Vehicle_C:GetCurrentGear(Gear, CurrentGear) end
---@param Torque double
function AAVS_Vehicle_C:GetTorque(Torque) end
---@param TargetSpeed double
function AAVS_Vehicle_C:GetTargetSpeed(TargetSpeed) end
---@param Location FVector
---@param Rotation FRotator
---@param KeepRelativeVelocity boolean
function AAVS_Vehicle_C:TeleportVehicle(Location, Rotation, KeepRelativeVelocity) end
---@param isBrakeApplied boolean
function AAVS_Vehicle_C:GetBrakeApplied(isBrakeApplied) end
---@param AirSpeed double
function AAVS_Vehicle_C:GetAirSpeed(AirSpeed) end
---@param Wheels TArray<UVehicle_Wheel_C>
function AAVS_Vehicle_C:GetAllWheels(Wheels) end
---@param LightGroup FName
---@param Active boolean
function AAVS_Vehicle_C:ToggleLightsActive(LightGroup, Active) end
---@param EngineRunning boolean
function AAVS_Vehicle_C:SetEngineRunning(EngineRunning) end
---@param EngineRunning boolean
function AAVS_Vehicle_C:GetEngineRunning(EngineRunning) end
function AAVS_Vehicle_C:StartEngine() end
function AAVS_Vehicle_C:ConstructWheels() end
function AAVS_Vehicle_C:ConstructComponents() end
function AAVS_Vehicle_C:OnRep_HandbrakeApplied() end
function AAVS_Vehicle_C:TickCosmetics() end
function AAVS_Vehicle_C:InitExhausts() end
function AAVS_Vehicle_C:TickWheels() end
---@param previousGear int32
---@param CurrentGear int32
function AAVS_Vehicle_C:GearChanged(previousGear, CurrentGear) end
---@param Initialized boolean
function AAVS_Vehicle_C:GetInitializationState(Initialized) end
---@param Message FString
---@param Error_ boolean
function AAVS_Vehicle_C:AVS_PrintDebugMessage(Message, Error_) end
---@param HasValidMesh boolean
function AAVS_Vehicle_C:InitVehicleMesh(HasValidMesh) end
function AAVS_Vehicle_C:ChangeGear() end
---@param LightGroup FName
---@param Active boolean
function AAVS_Vehicle_C:GetLightsActive(LightGroup, Active) end
---@param LightGroup FName
---@param Active boolean
function AAVS_Vehicle_C:SetLightsActive(LightGroup, Active) end
---@param LightController UVehicle_LightController_C
function AAVS_Vehicle_C:UpdateLightDecorations(LightController) end
function AAVS_Vehicle_C:UpdateLights() end
function AAVS_Vehicle_C:InitLights() end
---@param Simulate_ boolean
function AAVS_Vehicle_C:SetPhysics(Simulate_) end
---@param MoveUp boolean
---@param NewPos ShifterPositions::Type
function AAVS_Vehicle_C:MoveShifterPosition(MoveUp, NewPos) end
function AAVS_Vehicle_C:UpdateWheelLocks() end
function AAVS_Vehicle_C:UpdateBrakes() end
function AAVS_Vehicle_C:UpdateForces() end
function AAVS_Vehicle_C:UpdateInputs() end
function AAVS_Vehicle_C:EngineSimluation() end
---@param Mesh UMeshComponent
function AAVS_Vehicle_C:GetVehicleMesh(Mesh) end
function AAVS_Vehicle_C:InitWheels() end
function AAVS_Vehicle_C:PostConstructInit() end
function AAVS_Vehicle_C:UserConstructionScript() end
function AAVS_Vehicle_C:OwnerChanged() end
function AAVS_Vehicle_C:TeleportWheels() end
function AAVS_Vehicle_C:WakeWheelsForMovement() end
---@param EngineRunning boolean
function AAVS_Vehicle_C:RPC_Server_EngineRunning(EngineRunning) end
---@param Axis double
function AAVS_Vehicle_C:RPC_Server_Steering(Axis) end
---@param Throttle double
function AAVS_Vehicle_C:RPC_Server_Throttle(Throttle) end
---@param Brake double
function AAVS_Vehicle_C:RPC_Server_Brake(Brake) end
---@param Handbrake boolean
function AAVS_Vehicle_C:RPC_Server_Handbrake(Handbrake) end
---@param ShifterPosition ShifterPositions::Type
function AAVS_Vehicle_C:RPC_Server_Shifter(ShifterPosition) end
---@param TowHitch UVehicle_Hitch_C
---@param TrailerHitch UVehicle_Hitch_C
function AAVS_Vehicle_C:SetTrailerSyncMode(TowHitch, TrailerHitch) end
function AAVS_Vehicle_C:SendTrailerRotationRPC() end
---@param ServerTrailerRotation FRotator
function AAVS_Vehicle_C:RPC_Server_TrailerRotation(ServerTrailerRotation) end
function AAVS_Vehicle_C:ReceiveBeginPlay() end
AAVS_Vehicle_C['25 TPS'] = function(self, ) end
function AAVS_Vehicle_C:ReceiveDestroyed() end
---@param DeltaTime float
function AAVS_Vehicle_C:AVS_Tick(DeltaTime) end
AAVS_Vehicle_C['Reinit TPS'] = function(self, ) end
function AAVS_Vehicle_C:RunContactMod() end
---@param DeltaTime float
function AAVS_Vehicle_C:PassiveTickBP(DeltaTime) end
---@param OldController AController
---@param NewController AController
function AAVS_Vehicle_C:ReceiveControllerChanged(OldController, NewController) end
---@param EntryPoint int32
function AAVS_Vehicle_C:ExecuteUbergraph_AVS_Vehicle(EntryPoint) end
---@param IsEngineRunning boolean
function AAVS_Vehicle_C:OnEngineRunningUpdatedEvent__DelegateSignature(IsEngineRunning) end


